"use strict";
/////////////////////
// Builder interfaces and utilities for block builders
////
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getBuilders = exports.registerBuilder = void 0;
const fs_extra_1 = require("fs-extra");
const Path = __importStar(require("path"));
const all_builders = [];
function registerBuilder(builder) {
    all_builders.push(Object.freeze(builder));
}
exports.registerBuilder = registerBuilder;
async function getBuilders(block) {
    let builders = [];
    const replaceNames = new Set();
    for (const builder of all_builders) {
        let pass = false;
        if (typeof builder.predicate == 'string') {
            const builderFile = Path.join(block.dir, builder.predicate);
            pass = await (0, fs_extra_1.pathExists)(builderFile);
        }
        else {
            pass = await builder.predicate(block);
        }
        if (pass) {
            builders.push(builder);
            if (builder.replace) {
                builder.replace.forEach(n => replaceNames.add(n));
            }
        }
    }
    if (replaceNames.size > 0) {
        builders = builders.filter(b => !replaceNames.has(b.name));
    }
    builders.sort((a, b) => { var _a, _b; return ((_a = a.order) !== null && _a !== void 0 ? _a : 0) - ((_b = b.order) !== null && _b !== void 0 ? _b : 0); });
    return builders;
}
exports.getBuilders = getBuilders;
