import { BaseObj } from './base';
import { WebBundle } from './web-bundle-types';
export interface Block extends BaseObj {
    name: string;
    dir: string;
    webBundles?: WebBundle[];
    baseDistDir?: string;
    dbuildDependencies?: string | string[];
    [key: string]: any;
}
export declare type BlockByName = {
    [name: string]: Block;
};
export declare function updateVersions(config?: any): Promise<void>;
export declare function cleanNodeFiles(): Promise<void>;
/**
 *
 * @param names List of block name or block/bundle names
 */
export declare function buildBlocksOrBundles(names: string[]): Promise<void>;
export declare function watchBlock(blockName: string): Promise<void>;
export interface BuildOptions {
    watch?: boolean;
    full?: boolean;
    onlyBundleName?: string;
}
/**
 * Build a and block and eventually a bundle
 * @param blockName
 * @param opts
 */
export declare function buildBlock(blockOrName: string | Block, opts?: BuildOptions): Promise<void>;
export declare function loadDockerBlocks(): Promise<BlockByName>;
export declare function loadBlocks(): Promise<BlockByName>;
export declare function loadBlock(name: string): Promise<Block>;
