import { Block } from './block';
export declare function registerBuilder(builder: Builder): void;
export declare function getBuilders(block: Block): Promise<Builder[]>;
export interface Builder {
    name: string;
    /**
     * Predicate match to determine if the block has this build
     * - if string, then return true if match file name in block.dir
     * - if function, pass block as arg, and expect true/false */
    predicate: string | ((block: Block) => Promise<boolean>);
    order?: number;
    replace?: string[];
    build(block: Block, watch?: boolean): Promise<void>;
}
